$(document).ready(function () {
    showHideEventDate();
    var ContextualMenuElements = document.querySelectorAll(".ms-ContextualMenuContainer");
    for (var i = 0; i < ContextualMenuElements.length; i++) {
        var ButtonElementContextual = ContextualMenuElements[i].querySelector(".ms-Button-Contextual");
        var ContextualMenuElement = ContextualMenuElements[i].querySelector(".ms-ContextualMenu");
        new fabric['ContextualMenu'](ContextualMenuElement, ButtonElementContextual);
    }

    drawPopup("#leaveevent", "#leaveeventmodal", ".ms-Dialog-action");
    //Edit event button click pencil icon
       $('#editEventButton').click(function () {
     
        location.href="/usergroups/create-event/?isedit=true&eventid="+eventid;
    });
    // UG Landing Page tabpanel seithcing
    $(".msd-tab .msd-tabs-list button").click(function (e) {
        e.preventDefault();
        var selectTab = $(this).attr("id");
        $(".msd-pivot-btn").removeClass("msd-link-is-selected");
        $(".msd-pivot-btn").attr('aria-selected', 'false');
        $(this).addClass("msd-link-is-selected");
        $(this).attr('aria-selected', 'true');
        var tabName = $(this).attr("tab")
        $(".msd-tabpanel .tab-panel").addClass("hidden");
        $(".msd-tabpanel ." + selectTab).removeClass("hidden");
        if (selectTab == 'tab-group-info') {
            $('#similar_events_section').removeClass('hidden');
        } else {
            $('#similar_events_section').addClass('hidden');
        }
    });

    var activeTab = window.location.hash;
    const urlParams = new URLSearchParams(window.location.search);
    const activeTabParam = urlParams.get('activetab');
    if (activeTab == '#tab-discussion' || activeTab.contains('#tab-discussion') || activeTabParam == 'tab-discussion') {
        $('#tab-discussion').trigger("click");
        appendDiscussionTabHash();
    }
});

$(document).on("click", ".view-all-tab", function () {
    $("#tab-members").trigger("click");
})

$("#ms_event_add_to_calendar").click(function (e) {
    var meetingInfo = {
        startDate: $(this).attr("start-date-utc"),
        endDate: $(this).attr("end-date-utc"),
        location: $("#ms_event_location").val(),
        subject: $("#ms_event_subject").val(),
        emailTo: $("#ms_event_emailto").val(),
        description: $("#ms_event_cmty_excerpt").val() + '<br/>' + $("#ms_event_meetinglink").val(),
    };
    const startDate = meetingInfo.startDate || (new Date().toISOString());
    const endDate = meetingInfo.endDate || (new Date().toISOString());
    const location = meetingInfo.location || "";
    const subject = meetingInfo.subject || "";
    const emailTo = meetingInfo.emailTo || "";
    const description = meetingInfo.description || "";
    const icsMSG = "BEGIN:VCALENDAR\nVERSION:2.0\nPRODID:Calendar\nBEGIN:VEVENT\nUID:0@default\nDTSTAMP:20120315T170000Z\nDTSTART:" + startDate + "\nDTEND:" + endDate + "\nLOCATION:" + location + "\nSUMMARY:" + subject + "\nX-ALT-DESC;FMTTYPE=text/html:" + description + "\nEND:VEVENT\nEND:VCALENDAR" + "\nTRANSP:TRANSPARENT" + "\nCLASS:PUBLIC";
    $(this).attr("href", "data:text/calendar;charset=utf8," + icsMSG).attr("download", "AddCalendar.ics");
});

function LeaveEvent(e, recordid) {
    e.preventDefault()
    $("#cancel_event_container").block({ message: '', overlayCSS: { backgroundColor: '#e0dede', opacity: 0.6 } });
    deleteRecord("mspwrplt_cmty_communityeventregistrations", recordid, successCallback, errorCallback);
    function successCallback() {
        //reload the page
        location.reload();
    }
    function errorCallback() {
        console.log("Failed to cancel the registration ");
    }
}

function registerUserForEvent(e, eventId, userid, siteid) {
    try {
        if (eventId == undefined || eventId == "" || eventId == null) {
            return;
        }
        var eventRegisterationPayload = {
            "mspwrplt_cmty_attendee@odata.bind": "/contacts(" + userid + ")",
            "mspwrplt_cmty_communityevent@odata.bind": "/mspwrplt_cmty_communityevents(" + eventId + ")",
            "mspwrplt_cmty_site@odata.bind": "/mspwrplt_cmty_sites(" + siteid + ")",
        }
        $("#register_to_event").parent().block({ message: '', overlayCSS: { backgroundColor: '#e0dede', opacity: 0.6 } });
        createRecord("mspwrplt_cmty_communityeventregistrations", eventRegisterationPayload, successCallback, errorCallback);
        function successCallback(recordId, res, status, xhr) {
            //reload the page
           location.reload();
        }
        function errorCallback(res) {
            console.error("Unable to register the event");
        }
    } catch (exception) {
        console.error("Unable to register the event");
    }
}

$("#ms_event_join_similar_event,#ms_ug_event_join_similar_event, .ms_event_join_similar_event").click(function (e) {
    var eventId = $(this).attr("event-id");
    var id = $(this).attr('id');
    var siteId = $("#ms_event_siteid").val();
    var userId = $("#ms_event_userid").val();
    registerForEvent(id, eventId, siteId, userId);
});

function registerForEvent(id, eventId, siteId, userId) {
    try {
        if (eventId == undefined || eventId == "" || eventId == null) {
            return;
        }
        var eventRegisterationPayload = {
            "mspwrplt_cmty_attendee@odata.bind": "/contacts(" + userId + ")",
            "mspwrplt_cmty_communityevent@odata.bind": "/mspwrplt_cmty_communityevents(" + eventId + ")",
            "mspwrplt_cmty_site@odata.bind": "/mspwrplt_cmty_sites(" + siteId + ")",
        }
        $('#'+id).parent().block({ message: '', overlayCSS: { backgroundColor: '#e0dede', opacity: 0.6 } });
        createRecord("mspwrplt_cmty_communityeventregistrations", eventRegisterationPayload, successCallback, errorCallback);
        function successCallback(recordId, res, status, xhr) {
            //reload the page
            location.reload();
        }
        function errorCallback(res) {
            console.error("Unable to register the event");
        }
    } catch (exception) {
        console.error("Unable to register the event");
    }
}

//Event discussion tab
var event_discussionPageSize = $("#event_discussion_page_size").val();
var event_dicsussionPageNo = 2;
var eventId = $("#event_recid").val();
$("body").on("click", ".event-show-more-post", function () {
    $(this).parent().block({ message: '', overlayCSS: { backgroundColor: '#e0dede', opacity: 0.6 } });
    $(this).text('Loading..')
    var url = "/usergroups/eventdetails/discussion/?eventid=" + eventId + "&page_no=" + event_dicsussionPageNo + "&page_size=" + event_discussionPageSize;
    var id = $(this).attr('id');
    shell.ajaxSafePost({
        type: 'GET',
        url: url,
        global: false,
        success: function (data, textStatus, jqXHR) {
            $('#event-discussion-container').append(data);
            event_dicsussionPageNo++;
            var event_discussionViewedPageVal = parseInt($("#event_total_viewed_discussion").val());
            $("#event_total_viewed_discussion").val(event_discussionViewedPageVal + parseInt(event_discussionPageSize));
            $("#" + id).parent().unblock();
            if (parseInt($("#event_total_viewed_discussion").val()) < parseInt($("#event_total_discussion_count").val())) {
                $("#" + id).text('Show more');
            } else {
                $("#" + id).hide();
            }
        }
    }).fail(function (jqXhr) {
            var contentType = jqXhr.getResponseHeader("content-type");

            if (contentType == null || contentType == 'undefined' || contentType == undefined) 
            {
                console.error($.parseJSON(jqXhr));
            } else {
                var error = contentType.indexOf("json") > -1 ? $.parseJSON(jqXhr.responseText) : {
                    Message: jqXhr.status,
                    InnerError: {
                        Message: jqXhr.statusText
                    }
                };
                
                console.error(error);
            }
        $("#" + id).parent().unblock();
    });
});

var event_discussionReplyPageSize = $("#event_discussion_reply_page_size").val();
var event_reply_container_id = "";
var event_replyid = "";

$("body").on("click", ".event-more-forum-reply", function () {
    var event_discussionId = $(this).attr("discussionthreadid");
    var replyVisible = $('#all_replies_container_' + event_discussionId).attr('all-replies-visible');
    if (replyVisible == undefined || replyVisible == 'undefined') {
        $(this).parent().block({ message: '', overlayCSS: { backgroundColor: '#e0dede', opacity: 0.6 } });
        $(this).text('Loading..')
        var url = "/usergroups/eventdetails/discussion_reply/?threadid=" + event_discussionId + "&page_no=2";
        event_replyid = $(this).attr('id');
        event_reply_container_id = "event_thread_reply_container_" + event_discussionId;
        shell.ajaxSafePost({
            type: 'GET',
            url: url,
            global: false,
            success: function (data, textStatus, jqXHR) {
                $('#' + event_reply_container_id).prepend('<div all-replies-visible="true" id="all_replies_container_' + event_discussionId + '">' + data + '</div>');
                $("#" + event_replyid).parent().unblock();
                $("#" + event_replyid).text('Hide Previous Comment');
                event_reply_container_id = "";
                event_replyid = "";
                $('#first_page_thread_reply_container_' + event_discussionId).hide();
            }
        }).fail(function (jqXhr) {

            if (contentType == null || contentType == 'undefined' || contentType == undefined) 
            {
                console.error($.parseJSON(jqXhr));
            } else {
                var error = contentType.indexOf("json") > -1 ? $.parseJSON(jqXhr.responseText) : {
                    Message: jqXhr.status,
                    InnerError: {
                        Message: jqXhr.statusText
                    }
                };
                
                console.error(error);
            }
            $("#" + replyid).parent().unblock();
            event_reply_container_id = "";
            event_replyid = "";
        });
    } else {
        if (replyVisible == true || replyVisible == 'true') {
            $(this).text('Show previous comments');
            $('#all_replies_container_' + event_discussionId).attr('all-replies-visible', 'false');
            $('#all_replies_container_' + event_discussionId).hide();
            $('#first_page_thread_reply_container_' + event_discussionId).show();
        } else {
            $('#first_page_thread_reply_container_' + event_discussionId).hide();
            $('#all_replies_container_' + event_discussionId).show();
            $(this).text('Hide previous comments')
            $('#all_replies_container_' + event_discussionId).attr('all-replies-visible', 'true');
        }
    }
});

$("body").on("click", ".reply-to-forum-thread", function () {
    let id = $(this).attr('id')
    $('#event-reply-popup-modal').find("#mspwrplt_cmty_discussionthread").attr("value", id);
    $("#mspwrplt_cmty_discussionthread_entityname").attr("value", "mspwrplt_cmty_discussionthread");
    $('#event-reply-popup-modal').find('#target-threadid').val(id);
    $('#event-reply-popup-modal').find('#regarding_record_id').val(id);
});

$("body").on("click", "#new_thread_post_btn_event", function () {
   try {
        const discussionThreadType = defaultValues.cmty_discussionthreadtype_events; 
        let editorValue = $('#new_thread_post_container_event').find('iframe').contents().find('iframe').contents().find('.cke_editable').children().html();
        let _excerpt = strip_html_tags(editorValue);
        if (_excerpt.length > 150) {
            _excerpt = _excerpt.substring(0, 150) + "...";
        }
        const subject = _excerpt.substring(0, 100);

        if (validateUserInput(_excerpt, 'show_reply_editor_input_validation_msg') == true) {
            $(this).attr('value','Processing...');
            $(this).attr('disabled','disabled');
            let newThreadPostPayload = {
                "mspwrplt_cmty_body": editorValue,
                "mspwrplt_cmty_excerpt": _excerpt,
                "mspwrplt_name": subject,
                "mspwrplt_cmty_discussionthreadtype": discussionThreadType,
                "mspwrplt_cmty_discussionforum@odata.bind": "/mspwrplt_cmty_discussionforums(" + $('#group_event_forumid').val() + ")",
                "mspwrplt_cmty_site@odata.bind": "/mspwrplt_cmty_sites("+$("#event_details_siteid").val()+")",
                "mspwrplt_cmty_createdbyauthor@odata.bind": "/contacts("+$("#event_details_userid").val()+")",
                "mspwrplt_cmty_discussionthreadfor_mspwrplt_cmty_communityevent@odata.bind": "/mspwrplt_cmty_communityevents("+$("#event_details_eventid").val()+")",
            }
            createRecord("mspwrplt_cmty_discussionthreads", newThreadPostPayload, threadAdded, failedToPostThread);
            function threadAdded(recordId, res, status, xhr) {
                appendDiscussionTabHash();
                window.location.reload();
            }

            function failedToPostThread(res) {
                $('#new_thread_post_btn_event').attr('value','Post');
                $('#new_thread_post_btn_event').removeAttr("disabled");
            }
        }
    }catch(err) {
      $('#new_thread_post_btn_event').attr('value','Post');
      $('#new_thread_post_btn_event').removeAttr("disabled");
      console.error(err);
    }
});

function validateUserInput(value, id) {
    let isValid = false;
    if (value == '' || value == undefined || value == '<br>' || value == "<br/>") {
        $('#ValidationSummary_Post_Thread_Error').removeClass('hidden');
    } else {
        isValid = true;
    }
    return isValid;
}

$('#event-reply-popup-modal').on('hidden.bs.modal', function () {
    $(this).find('#target-threadid').val('');
    $(this).find('#regarding_record_id').val('');
    $('#user_reply_description_val').find('iframe').contents().find('iframe').contents().find('.cke_editable').children().html('');
})

$(document).ready(function () {
    $("#mspwrplt_cmty_site").val($("#event_details_siteid").val());
    $("#mspwrplt_cmty_createdbyauthor").val($("#event_details_userid").val());
    var eventname = $("#event_details_eventname").val();
    $(`<button type="button" class="msd-button msd-Button--default ms-Button ms-Dialog-action msd-btn msd-btn-default" data-dismiss="modal">Close</button>`).insertAfter("#InsertButton");
    $('<input type="button" value="Post" id="Reply_Event_Post_Button_Custom" title="Post" onclick="" class="submit-btn btn btn-primary form-action-container-left msd-btn msd-btn-primary">').insertAfter($($('#event-reply-popup-modal').find('#InsertButton')));
    $($('#event-reply-popup-modal').find('#InsertButton')).remove(); //Removed OOTB Update button to thread reply.
    $("#mspwrplt_name").parent().hide();
    $(".entity-form .tab-title").hide();
    $("#mspwrplt_name").val(eventname + " Forum Thread");
    $("#mspwrplt_cmty_createdbyauthor").parent().hide();
    $("#mspwrplt_cmty_createdbyauthor").attr("value", Microsoft.Dynamic365.Portal.User.contactId);
    $("#mspwrplt_cmty_createdbyauthor_entityname").attr("value", "contact");
    $('#mspwrplt_cmty_createdbyauthor, #mspwrplt_cmty_createdbyauthor_label').hide();
    $("#mspwrplt_cmty_site").parent().hide();
    $("#mspwrplt_cmty_site_name").attr("value", $("#event_details_siteName").val());
    $("#mspwrplt_cmty_site").attr("value", $("#event_details_siteid").val());
    $("#mspwrplt_cmty_site_entityname").attr("value", "mspwrplt_cmty_site");
    $("#mspwrplt_cmty_discussionthread").parent().hide();
});

function appendDiscussionTabHash(){
    if(!window.location.hash.contains('#tab-discssion')){
     window.location.hash = '#tab-discussion';
    }
}

function showHideEventDate() {
    var dateFormat = $("#dateformat").val();
    var startDate = moment($("#ms_event_startdate").val()).format(dateFormat);
    var endDate = moment($("#ms_event_enddate").val()).format(dateFormat);

    if (startDate === endDate) {
        $('#singleeventdateformat').removeClass('hide');
    }
    else {
        $('#multieventdateformat').removeClass('hide');
    }
}

//Event details reply under a thread post
$(document).ready(function () {
    $('#Reply_Event_Post_Button_Custom').on('click', function (e) {
        let eventThreadReplyDescription = $('#mspwrplt_cmty_body').val().replaceAll("\\n", "").replaceAll("\\t", "").replaceAll("\"", "").replace(/\\/g, "/").replaceAll("size=full/", "size=full").replaceAll("//api", "/api").replaceAll("/https", "https").trim();           
        let _excerpt = strip_html_tags(eventThreadReplyDescription);
        if(validateUserReplyInput_Event(_excerpt,'ValidationSummary_Post_Event_Reply_Error')){
            $(this).attr('disabled', 'disabled');
            $(this).attr('value', 'Processing...');
            let entityName = "mspwrplt_cmty_discussioncomments";
            var threadReplyPayload = {
                "mspwrplt_name": $('#mspwrplt_name').val(),
                "mspwrplt_cmty_body": eventThreadReplyDescription,
                "mspwrplt_cmty_createdbyauthor@odata.bind": "/contacts(" + Microsoft.Dynamic365.Portal.User.contactId + ")",
                "mspwrplt_cmty_site@odata.bind": "/mspwrplt_cmty_sites(" + $('#mspwrplt_cmty_site').val() + ")",
                "mspwrplt_cmty_discussionthread@odata.bind": "/mspwrplt_cmty_discussionthreads(" + $('#mspwrplt_cmty_discussionthread').val()+ ")"
            };

            //Create discussion reply record.
            createRecord(entityName, threadReplyPayload, successReplied, failedToReply);
            function successReplied(recordId, res, status, xhr) {
                $('#Reply_Event_Post_Button_Custom').removeAttr("disabled");
                $('#Reply_Event_Post_Button_Custom').attr('value', 'Post');
                refreshEventThreadReplies($('#mspwrplt_cmty_discussionthread').val());
                $("#event-reply-popup-modal").modal("hide");
            }

            function failedToReply(res) {
                $('#Reply_Event_Post_Button_Custom').removeAttr("disabled");
                $('#Reply_Event_Post_Button_Custom').attr('value', 'Post');
                console.error(res);
            }
        }
    });
});

function refreshEventThreadReplies(discussionId) {
    ShowLoader();
    var currentReplySize = $('#event_thread_reply_container_' + discussionId).find('.reply-panel').size();
    let url = "/usergroups/eventdetails/discussion_reply/?threadid=" + discussionId + "&page_no=1&page_size=" + $("#event_discussionReplyPageSize").val();
    var reply_container_id = "event_thread_reply_container_" + discussionId;
    var thread_replyid = 'show_more_event_reply_' + discussionId;
    shell.ajaxSafePost({
        type: 'GET',
        url: url,
        global: false,
        success: function (data, textStatus, jqXHR) {
            $('#first_page_thread_reply_container_' + discussionId).html('').html(data);
            $('#all_replies_container_' + discussionId).hide();
            $('#first_page_thread_reply_container_' + discussionId).show();
            $('#all_replies_container_' + discussionId).removeAttr('all-replies-visible');
            $("#" + thread_replyid).text('Show previous comment');

            if (currentReplySize == Number($("#event_discussionReplyPageSize").val())) {
                $('#event_show_more_reply_container_' + discussionId).removeClass('hidden');
            }
            FormatDateTime();
            HideLoader();
        }
    }).fail(function (jqXhr) {
        var contentType = jqXhr.getResponseHeader("content-type");
        var error = contentType.indexOf("json") > -1 ? $.parseJSON(jqXhr.responseText) : {
            Message: jqXhr.status,
            InnerError: {
                Message: jqXhr.statusText
            }
        };
        HideLoader();
        console.error(error);
    });
}

function validateUserReplyInput_Event(value, id) {
    let isValid = false;
    if (value == '' || value == undefined || value == '<br>' || value == "<br/>") {
        $('#'+id).removeClass('hidden');
    } else {
        isValid = true;
    }
    return isValid;
}

$('#event-reply-popup-modal').on('hidden.bs.modal', function () {
    $('#mspwrplt_cmty_body').val('');
    $('#ValidationSummary_Post_Event_Reply_Error').addClass('hidden');
})